/* 
   main.c
   compilare: gcc -Wall --pedantic main.c coda.c -o prova
   (R. Grossi, 2013)
*/

#include <stdlib.h>
#include <stdio.h>
#include <assert.h>
#include "coda.h"

int main( ){
  coda *mia = Create( );
  coda *tua = Create( );

  printf( "mia: "); Print( mia );
  printf( "tua: "); Print( tua );

  Enqueue( mia, 5 );
  printf( "mia: "); Print( mia );
  printf( "tua: "); Print( tua );

  Enqueue( mia, 7 );
  printf( "mia: "); Print( mia );
  printf( "tua: "); Print( tua );

  Enqueue( mia, 5 );
  printf( "mia: "); Print( mia );
  printf( "tua: "); Print( tua );

  printf( ELEMENTO_PRINTF, Dequeue( mia ) );
  printf( ", " );
  printf( "mia: "); Print( mia );
  printf( "tua: "); Print( tua );

  Enqueue( mia, 2 );
  printf( "mia: "); Print( mia );
  printf( "tua: "); Print( tua );

  Enqueue( tua,  Dequeue( mia ) );
  printf( "mia: "); Print( mia );
  printf( "tua: "); Print( tua );
  
  Enqueue( tua, 9 );
  printf( "mia: "); Print( mia );
  printf( "tua: "); Print( tua );

  if ( !Empty(tua) ) {
    printf( ELEMENTO_PRINTF, First( tua ) );
    printf( "\n" );
  }

  mia = Destroy( mia );
  tua = Destroy( tua );

  return 0;
}
